<template>
  <div style="z-index: 0" :class="{ 'flex items-stretch text-sm': true, 'flex-row': !thin, 'flex-col': thin }">
    <status-indicator-tag
      @click="modals.show('postpone-picker', $event)"
      :class="{
        'rounded-b-none rounded-t-lg justify-center': thin,
        'rounded-r-none rounded-l-full': !thin,
        'clickable-bg': true
      }"
      :color="postponed.show ? 'gray' : ''"
    >
      <i
        :class="{
          'hero arrow-circle-right': true,
          '-ml-1 -mr-2 outline': !postponed.show,
          'solid mr-2': postponed.show
        }"
      ></i>
      <div v-if="postponed.show">
        {{ task.postponedUntil?.toLocaleString({ weekday: "short", month: "short", day: "2-digit" }) }}
      </div>
    </status-indicator-tag>
    <status-indicator-tag
      @click="modals.show('date-picker', $event)"
      :class="{
        'rounded-b-none rounded-t-none clickable-bg': true,
        '-my-px justify-center': thin,
        '-mx-px': !thin
      }"
      :color="date.show ? date.color : undefined"
    >
      <i
        :class="{
          'hero calendar': true,
          '-mx-1 outline': !date.show,
          'solid mr-2': date.show
        }"
      ></i>
      <div v-if="date.show">
        {{ date.text }}
      </div>
    </status-indicator-tag>
    <status-indicator-tag
      @click="modals.show('deadline-picker', $event)"
      :class="{
        'rounded-t-none rounded-b-lg justify-center': thin,
        'rounded-l-none rounded-r-full': !thin,
        'clickable-bg': true
      }"
      :style="{
        'z-index': date.show ? '-1' : 'auto'
      }"
      :color="deadline.show ? deadline.color : undefined"
    >
      <i
        :class="{
          'hero flag': true,
          '-mx-1 outline': !deadline.show,
          'solid mr-2': deadline.show
        }"
      ></i>
      <div v-if="deadline.show">
        {{ deadline.text }}
      </div>
    </status-indicator-tag>
    <modal :is="modals.get('postpone-picker')" :task="task" />
    <modal :is="modals.get('date-picker')" :task="task" />
    <modal :is="modals.get('deadline-picker')" :task="task" />
  </div>
</template>

<script lang="ts">
import Tag from "@/components/Tag.vue";
import { useModals } from "@/use/modal";
import TaskPostponedPickerVue from "../TaskPostponedPicker.vue";
import Task from "@/models/Task";
import TaskDeadlinedPickerVue from "../TaskDeadlinedPicker.vue";
import StatusIndicatorTag from "@/components/StatusIndicatorTag.vue";
import { computed } from "vue";
import TaskDatePickerVue from "../TaskDatePicker.vue";

export default {
  components: { Tag, StatusIndicatorTag },
  props: {
    task: {
      type: Task,
      required: true
    },
    thin: {
      type: Boolean,
      default: false
    }
  },
  setup(props) {
    const postponed = computed(() => ({
      show: props.task.isPending() && props.task.isPostponed
    }));
    const deadline = computed(() => ({
      show: props.task.isDeadlined,
      color: props.task.isOverdue() ? "red" : props.task.isToday() ? "blue" : "gray",
      text: props.task.isToday()
        ? "today"
        : props.task.isOverdue()
        ? props.task.overdueSince()?.as("days") + " days ago"
        : props.task.deadlineAt?.toLocaleString({ weekday: "short", month: "short", day: "2-digit" })
    }));
    const date = computed(() => ({
      show: props.task.isDate,
      color: props.task.isOverdue() ? "red" : props.task.isToday() ? "blue" : "gray",
      text: props.task.isToday()
        ? "today"
        : props.task.isOverdue()
        ? props.task.overdueSince()?.as("days") + " days ago"
        : props.task.postponedUntil?.toLocaleString({ weekday: "short", month: "short", day: "2-digit" })
    }));
    return {
      modals: useModals({
        PostponePicker: TaskPostponedPickerVue,
        DeadlinePicker: TaskDeadlinedPickerVue,
        DatePicker: TaskDatePickerVue
      }),
      postponed,
      date,
      deadline,
      thin: computed(() => props.thin && postponed.value.show && deadline.value.show)
    };
  }
};
</script>
